本文出自 “夜的博客” 博客http://freeze.blog.51cto.com/1846439/386132

本人转载

朋友们对LAMP架构应该比较熟悉了,Linux+Apache+Mysql+Php/perl/python),LEMP架构只是把提供web服务的Apache改用为Nginx。从而形成,Linux+Nginx+Mysql+Php/perl/python)架构。目前企业级别应用Nginx在创下许多惊人战绩。
目前国内以张宴为代表,掀起了nginx的狂潮,首先简单介绍下什么是nginx.
Nginx(发音同 engine x)是一款轻量级的Web 服务器/反向代理服务器及电子邮件(IMAP/POP3)代理服务器,并在一个BSD-like 协议下发行。由俄罗斯的程序设计师Igor Sysoev所开发,最初供俄国大型的入口网站及搜寻引擎Rambler(俄文:Рамблер)使用。  其特点是占有内存少,并发能力强,事实上nginx的并发能力确实在同类型的网页伺服器中表现较好.目前中国大陆使用nginx网站用户有:新浪、网易、 腾讯,另外知名的微网志Plurk也使用nginx。
 
为什么Nginx的性能要比Apache高得多?
这得益于Nginx使用了最新的epoll(Linux 2.6内核)和kqueue(freebsd)网络I/O模型,而Apache则使用的是传统的select模型。目前Linux下能够承受高并发访问的 Squid、Memcached都采用的是epoll网络I/O模型。

处理大量的连接的读写,Apache所采用的select网络I/O模型非常低效。
Nginx 是一个很牛的高性能Web和反向代理服务器, 它具有有很多非常优越的特性:
 
作为 Web 服务器:相比 Apache,Nginx 使用更少的资源,支持更多的并发连接,体现更高的效率,这点使 Nginx 尤其受到虚拟主机提供商的欢迎。在高连接并发的情况下,Nginx是Apache服务器不错的替代品: Nginx在美国是做虚拟主机生意的老板们经常选择的软件平台之一. 能够支持高达 50,000 个并发连接数的响应, 感谢Nginx为我们选择了 epoll and kqueue 作为开发模型.
Nginx作为负载均衡服务器: Nginx 既可以在内部直接支持 Rails 和 PHP 程序对外进行服务, 也可以支持作为 HTTP代理 服务器对外进行服务. Nginx采用C进行编写, 不论是系统资源开销还是CPU使用效率都比 Perlbal 要好很多. 。Nginx可作为7层负载均衡服务器来使用。
作为邮件代理服务器: Nginx 同时也是一个非常优秀的邮件代理服务器(最早开发这个产品的目的之一也是作为邮件代理服务器), Last.fm 描述了成功并且美妙的使用经验.
Nginx 是一个安装非常的简单 , 配置文件非常简洁(还能够支持perl语法), Bugs 非常少的服务器: Nginx 启动特别容易, 并且几乎可以做到7*24不间断运行,即使运行数个月也不需要重新启动. 你还能够不间断服务的情况下进行软件版本的升级 .
总体来说nginx的有以下八大优点:
1.高并发连接:官方测试能支撑5万并发连接,在实际生产环境中跑到2,~3W并发连接。
2.内存消耗少:在3W并发连接下,开启的10个NGINX进程才消耗150M内存(15M*10=150M)
3.配置文件非常简单:风格跟程序一样通俗易懂。
4.成本低廉:Nginx作为开源软件,可以免费使用,而购买F5 BIG-IP、NetScaler
等硬件负载均衡交换机则需要十多万至几十万人民币。
5.支持rewrite重写规则:能够根据域名、URL的不同,将HTTP请求分发到不同的后端服务器群组。
6.内置的健康检查功能:如果Nginx Proxy后端的后台web服务器宕机了,不会音响前端访问。
7.节省带宽:支持GZIP压缩,可以添加浏览器本地缓存的Header头。
8.稳定性高:用于反向代理,宕机的概率微乎其微。
 
介绍这么多nginx 的优点.下面来具体实现下LEMP架构(linux+nginx+mysql+php/perl/python)
可能有朋友对静态动态解析过程不太清楚,笔者按照自己理解简单阐述,如有错误地方请前辈多加指点。
nginx只是提供一个静态web服务,动态web服务还需要与PHP等脚本语言结合使用。如图所示:
 客户端在访问动态页面时,因为apache和nginx只能提供静态解析,这是他们通过内置的cgi接口去寻找php等脚本语言,当需要用到数据部分时PHP会去调用后台MYSQL数据库中的数据,之后通过解析生成静态页面在返回apache/nginx服务器,再由此交付给客户端。
 
如果不清楚CGI和fastCGI笔者作以下简要说明:
 Perl、Python或者PHP原来在Web开发的时候应用得比较多,因为早期的web服务器(当然还包括Apache)内建了CGI(通用网关接口) 接口。CGI能够以确定的方式让Web服务器在客户机的浏览器和外部应用程序之间交换数据。通过支持外部的、基于CGI的应用程序,Web开发人员能够引 进动态要素。使用这种接口开发经过编译的应用程序相对来说比较复杂,但是,这种解释性的语言通常包括这种功能,或者是直接包括这种功能(如使用PHP), 或者通过标准模块包括这种功能(如使用Perl和Python)。
FastCGI同CGI一样是一个WEB服务器与外部程序接口的标准,它是为解决CGI的性能问题而开发的一种技术。
CGI技术的性能缺陷:每当服务器收到一个对CGI程序请求时,服务器都将创建一个CGI程序的进程,CGI程序处理完请求后,将输出发给服务器或直接传回客户端,然后终止。
 
fastCGI对CGI技术进行了改良,一个fastCGI进程在WEB服务器启动时或在客户端第一次请求时创建,它处理完客户端请求后并不终 止,而是等待处理下一个请求。另外fastCGI程序与CGI程序与服务器的交互方式也不同,CGI程序通过环境变量、命令行、标准输入输出进行交互,因 此CGI程序进程必须与服务器进程在同一台物理计算机上,而fastCGI程序与服务器进程通过网络连接交互,因此fastCGI程序可以分布在不同的计 算机上,这不但可以提高性能,同时也提高了系统的扩展能力。
 
 
下面开始源码架设LEMP架构:
笔者所使用的平台为RHEL5.4   kernel版本2.6.18-164
2010年9月1日笔者在nginx官方网站上获得的最新nginx版本信息
 

简单介绍所用包的关系以及原理
1.mysql-5.5.3-m3.tar.gz       #LEMP架构中担当数据库服务器即M
2.Nginx-0.7.65.tar.gz            #提供web服务,提供静态web服务
3.php5.3.3.tar.bz2        #提供php脚本语言用来解析动态页面 
需要说明以下几点:
php在编译安装时,nginx要想能够调用php提供动态php格式的网页,必须用FastCGI来实现,但 FastCGI只是一个框架,实现FastCGI框架的有PHP-FPM,但对于5.2.x版本的php来说 默认是不支持PHP-FPM的,需要打上php-fpm的补丁,对于5.3.2之前版本的也是需要打补丁的,而且打补丁的过程比较麻烦。好在5.3.3版 本的PHP-FPM被直接做进了源代码包中,在编译安装时只需启用PHP-FPM功能即可,笔者为了简要实现功能,选用5.3.3版本来进行演示。
但如果要使用PHP-FPM的话,还需要提供以下几个功能:
a.需要提供可以解析xml格式的文档,需要安装libxml2 和libxml2-devel这两个包,好在这两个包在安装完开发环境后这两个包是默认安装过的。
b.需要安装libevent并且在1.4.12之后的版本,不幸的是rhel5.4版本中这个包是是在1.4.12之前的,需要从新手动编译安装该包。
c. libiconv 用来提供网络连接方式的功能组件,可以实现更快速的网络访问,这个组件系统上是没有装的,需要手动编译安装。
 
 通过以上说明,剩下2个包的作用应该是有所了解了。
4.libevent-1.4.14b-stable-tar.gz
5.libconv-1.13.1.tar.gz
好了,所有的准备活动已经就绪,接下来开始正式的源码搭建LEMP架构
 
首先需要构建编译环境可以直接挂载光盘进行yum安装
 
yum -y install gcc openssl-devel zlib-devel pcre-devel
yum groupinstall "Developement Tools" "Development Libraries" -yt

 
 
好了安装完开发环境下面就开始源码安装LEMP组件了
 
Nginx
首先进入你源码包的目录,笔者放置的目录是/root/soft

 

执行上面最后一条语句解压

 

 

tar zxvf nginx-0.7.65.tar.gz

cd nginx-0.7.65

useradd -s /sbin/nologin -M nginx  # 添加一个不能登录的且没有家目录 名为nginx的用户

./configure \                                                     #开始编译 所带的参数很容易理解笔者不多解释
  --prefix=/usr \
  --sbin-path=/usr/sbin/nginx \
  --conf-path=/etc/nginx/nginx.conf \
  --error-log-path=/var/log/nginx/error.log \
  --http-log-path=/var/log/nginx/access.log \
  --pid-path=/var/run/nginx/nginx.pid  \
  --lock-path=/var/lock/nginx.lock \
  --user=nginx \
  --group=nginx \
  --with-http_ssl_module \
  --with-http_flv_module \
  --with-http_stub_status_module \
  --with-http_gzip_static_module \
  --http-client-body-temp-path=/var/tmp/nginx/client/ \
  --http-proxy-temp-path=/var/tmp/nginx/proxy/ \
  --http-fastcgi-temp-path=/var/tmp/nginx/fcgi/
 

编译完成后没有报错就可以安装了。

make && make install
 

编译安装完成后为了让nginx开机启动,笔者提供个systemV风格的脚本

vim /etc/init.d/nginxd


 

把以下内容粘贴进去

 

 #!/bin/sh
#
# nginx - this script starts and stops the nginx daemon
#
# chkconfig:   - 85 15
# description:  Nginx is an HTTP(S) server, HTTP(S) reverse \
#               proxy and IMAP/POP3 proxy server
# processname: nginx
# config:      /etc/nginx/nginx.conf
# config:      /etc/sysconfig/nginx
# pidfile:     /var/run/nginx.pid

# Source function library.
. /etc/rc.d/init.d/functions

# Source networking configuration.
. /etc/sysconfig/network

# Check that networking is up.
[ "$NETWORKING" = "no" ] && exit 0

nginx="/usr/sbin/nginx"
prog=$(basename $nginx)

NGINX_CONF_FILE="/etc/nginx/nginx.conf"

[ -f /etc/sysconfig/nginx ] && . /etc/sysconfig/nginx

lockfile=/var/lock/subsys/nginx

make_dirs() {
   # make required directories
   user=`nginx -V 2>&1 | grep "configure arguments:" | sed 's/[^*]*--user=\([^ ]*\).*/\1/g' -`
   options=`$nginx -V 2>&1 | grep 'configure arguments:'`
   for opt in $options; do
       if [ `echo $opt | grep '.*-temp-path'` ]; then
           value=`echo $opt | cut -d "=" -f 2`
           if [ ! -d "$value" ]; then
               # echo "creating" $value
               mkdir -p $value && chown -R $user $value
           fi
       fi
   done
}

start() {
    [ -x $nginx ] || exit 5
    [ -f $NGINX_CONF_FILE ] || exit 6
    make_dirs
    echo -n $"Starting $prog: "
    daemon $nginx -c $NGINX_CONF_FILE
    retval=$?
    echo
    [ $retval -eq 0 ] && touch $lockfile
    return $retval
}

stop() {
    echo -n $"Stopping $prog: "
    killproc $prog -QUIT
    retval=$?
    echo
    [ $retval -eq 0 ] && rm -f $lockfile
    return $retval
}

restart() {
    configtest || return $?
    stop
    sleep 1
    start
}

reload() {
    configtest || return $?
    echo -n $"Reloading $prog: "
    killproc $nginx -HUP
    RETVAL=$?
    echo
}

force_reload() {
    restart
}

configtest() {
  $nginx -t -c $NGINX_CONF_FILE
}

rh_status() {
    status $prog
}

rh_status_q() {
    rh_status >/dev/null 2>&1
}

case "$1" in
    start)
        rh_status_q && exit 0
        $1
        ;;
    stop)
        rh_status_q || exit 0
        $1
        ;;
    restart|configtest)
        $1
        ;;
    reload)
        rh_status_q || exit 7
        $1
        ;;
    force-reload)
        force_reload
        ;;
    status)
        rh_status
        ;;
    condrestart|try-restart)
        rh_status_q || exit 0
            ;;
    *)
        echo $"Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload|configtest}"
        exit 2
esac


 

 

保存退出 并给/etc/init.d/nginxd 赋予执行权限

chmod +x /etc/init.d/nginxd

chkconfig --add nginxd        ##让入开机启动选项中

chkconfig nginxd on          #让其开机自动启动

service nginxd  start       #立即启动nginx 服务

 

出现OK字样 并且通过web浏览器 访问该主机出现以下画面 表示nginx 编译完成并成功启动

下面是编译安装MYSQL

Mysql

 

先解压缩mysql-5.5.3-m3.tar.gz  需进入该源码包所在目录 笔者目录为/root/soft

tar zxvf mysql-5.5.3-m3.tar.gz                           #解压缩到当前目录

cd mysql-5.5.3-m3/

/usr/sbin/groupadd mysql                           #添加mysql用户
/usr/sbin/useradd -g mysql mysql            #添加mysql组
 

开始编译、安装   (具体参数不多介绍,都是些基本功能的启用,有兴趣者可以查看mysql的官方文档)


./configure --prefix=/usr/local/webserver/mysql/ --enable-assembler --with-extra-charsets=complex --enable-thread-safe-client --with-big-tables --with-readline --with-ssl --with-embedded-server --enable-local-infile --with-plugins=partition,innobase,myisammrg
make && make install                                                                                        

 编译安装时间可能有些长,需要耐心等待。。

chmod +w /usr/local/webserver/mysql                                           #给mysql目录写的权限
chown -R mysql:mysql /usr/local/webserver/mysql                     #改变mysql目录的属组和属主为mysql

cd /

mkdir /mysql/{data,binlog,relaylog} -p                                #创建mysql数据库、日志存放目录
chown -R mysql:mysql /mysql                                             #改变/mysql的属组和属主为mysql  

以mysql用户帐号的身份建立数据表

/usr/local/webserver/mysql/bin/mysql_install_db --basedir=/usr/local/webserver/mysql -- --datadir=/mysql/data --user=mysql
 

手动创建Mysql的配置文件

 

 vim /mysql/my.cnf
 

[client]
character-set-server = utf8
port    = 3306
socket  = /tmp/mysql.sock

[mysqld]
character-set-server = utf8
replicate-ignore-db = mysql
replicate-ignore-db = test
replicate-ignore-db = information_schema
user    = mysql
port    = 3306
socket  = /tmp/mysql.sock
basedir = /usr/local/webserver/mysql
datadir = /mysql/data
log-error = /mysql/mysql_error.log
pid-file = /mysql/mysql.pid
open_files_limit    = 10240
back_log = 600
max_connections = 5000
max_connect_errors = 6000
table_cache = 614
external-locking = FALSE
max_allowed_packet = 32M
sort_buffer_size = 1M
join_buffer_size = 1M
thread_cache_size = 300
#thread_concurrency = 8
query_cache_size = 512M
query_cache_limit = 2M
query_cache_min_res_unit = 2k
default-storage-engine = MyISAM
thread_stack = 192K
transaction_isolation = READ-COMMITTED
tmp_table_size = 246M
max_heap_table_size = 246M
long_query_time = 3
log-slave-updates
log-bin = /data0/mysql/3306/binlog/binlog
binlog_cache_size = 4M
binlog_format = MIXED
max_binlog_cache_size = 8M
max_binlog_size = 1G
relay-log-index = /mysql/relaylog/relaylog
relay-log-info-file = /mysql/relaylog/relaylog
relay-log = /mysql/relaylog/relaylog
expire_logs_days = 30
key_buffer_size = 256M
read_buffer_size = 1M
read_rnd_buffer_size = 16M
bulk_insert_buffer_size = 64M
myisam_sort_buffer_size = 128M
myisam_max_sort_file_size = 10G
myisam_repair_threads = 1
myisam_recover

interactive_timeout = 120
wait_timeout = 120

skip-name-resolve
#master-connect-retry = 10
slave-skip-errors = 1032,1062,126,1114,1146,1048,1396

#master-host     =   192.168.1.1
#master-user     =   username
#master-password =   password
#master-port     =  3306

server-id = 1

innodb_additional_mem_pool_size = 16M
innodb_buffer_pool_size = 512M
innodb_data_file_path = ibdata1:256M:autoextend
innodb_file_io_threads = 4
innodb_thread_concurrency = 8
innodb_flush_log_at_trx_commit = 2
innodb_log_buffer_size = 16M
innodb_log_file_size = 128M
innodb_log_files_in_group = 3
innodb_max_dirty_pages_pct = 90
innodb_lock_wait_timeout = 120
innodb_file_per_table = 0

#log-slow-queries = /mysql/slow.log
#long_query_time = 10

[mysqldump]
quick
max_allowed_packet = 32M

创建管理MySQL数据库的shell脚本

 

 vim /mysql/mysqld
 

###注意 下面的3,4行账号密码可以自行创建,第2行的默认端口3306一般不要改

#!/bin/sh
mysql_port=3306
mysql_username="admin"
mysql_password="123456"

function_start_mysql()
{
    printf "Starting MySQL...\n"
    /bin/sh /usr/local/webserver/mysql/bin/mysqld_safe --defaults-file=/mysql/my.cnf 2>&1 > /dev/null &
}

function_stop_mysql()

{
    printf "Stoping MySQL...\n"
    /usr/local/webserver/mysql/bin/mysqladmin -u ${mysql_username}

-p${mysql_password} -S /tmp/mysql.sock shutdown
}

function_restart_mysql()
{
    printf "Restarting MySQL...\n"
    function_stop_mysql
    sleep 5
    function_start_mysql
}

function_kill_mysql()
{
    kill -9 $(ps -ef | grep 'bin/mysqld_safe' | grep ${mysql_port} | awk '{printf $2}')
    kill -9 $(ps -ef | grep 'libexec/mysqld' | grep ${mysql_port} | awk '{printf $2}')
}

if [ "$1" = "start" ]; then
    function_start_mysql
elif [ "$1" = "stop" ]; then
    function_stop_mysql
elif [ "$1" = "restart" ]; then
function_restart_mysql
elif [ "$1" = "kill" ]; then
function_kill_mysql
else
    printf "Usage: /mysql/mysqld {start|stop|restart|kill}\n"
fi

 

 

     赋给shell脚本可执行权限

chmod    +x   /mysql/mysqld                         #该脚本可以用/mysql/mysqld        start  |restart |stop 来执行

 

 

启动Mysql:

/mysql/mysqld start

通过命令行登录管理MySQL服务器(提示输入密码时直接回车):

/usr/local/webserver/mysql/bin/mysql -u root -p -S /tmp/mysql.sock

输入以下SQL语句,创建一个具有root权限的用户(admin)和密码(123456):
 

GRANT ALL PRIVILEGES ON *.* TO 'admin'@'localhost' IDENTIFIED BY '123456';
GRANT ALL PRIVILEGES ON *.* TO 'admin'@'127.0.0.1' IDENTIFIED BY '123456';

 


 


 至此Mysql已全部配置完成

 

PHP

 首先 需要解压编译安装

libevent-1.4.14b-stable-tar.gz
libconv-1.13.1.tar.gz

 cd /root/soft

解压编译安装libevent-1.4.14b-stable

tar zxvf libevent-1.4.14b-stable.tar.gz

cd  libevent-1.4.14b-stable

./configure && make && make install

---------------------------------------------------------------------------------------------------------

cd /root/soft

tar zxvf  libconv-1.13.1.tar.gz

cd libiconv-1.13.1
 ./configure
make && make install

 

 
 好了,安装PHP的准备工作完成,下面开始编译安装PHP

 cd /root/soft
 

 tar jxvf php-5.3.3.tar.bz2

cd php-5.3.3

./configure --prefix=/usr/local/php --with-mysql=/usr/local/webserver/mysql --with-mysqli=/usr/local/webserver/mysql/bin/mysql_config  --with-openssl --enable-fpm  --with-libevent-dir=/usr/local --enable-mbstring --with-freetype-dir --with-jpeg-dir --with-png-dir --with-zlib --with-libxml-dir=/usr --enable-xml --with-iconv-dir=/usr/local

#需要说明两点 1.--with-mysql和--with-mysqli的路径是你mysql的具体所在的目录

                             2.--enable-fpm 启动fpm  .其他都是些基本选项 ,简单易懂

出现以下画面表示编译成功

下面就是安装了

make ZEND_EXTRA_LIBS='-liconv'        #因为-liconv的目录不是在/usr/local下所以安装时需要手动指定

说明:

如果在make 时,mysql的路径没有错误,但一直error,尝试使用低版本的mysql在进行此步骤,因为可能存在版本差异的路径bug。。
make install 

cp /root/soft/php-5.3.3/php.ini-production  /usr/local/php/etc/php.ini

 

 

 全部安装工作准备已经完成,剩下进行一些配置.

 

首先修改下面来配置修改 /usr/local/php/etc/php-fpm.conf

该配置文件只用修改以下四点

; Note: Used when pm is set to either 'static' or 'dynamic'
; Note: This value is mandatory.
pm.max_children = 50

; The number of child processes created on startup.
; Note: Used only when pm is set to 'dynamic'
; Default Value: min_spare_servers + (max_spare_servers - min_spare_servers) / 2
pm.start_servers = 10

; The desired minimum number of idle server processes.
; Note: Used only when pm is set to 'dynamic'
; Note: Mandatory when pm is set to 'dynamic'
pm.min_spare_servers = 5

; The desired maximum number of idle server processes.
; Note: Used only when pm is set to 'dynamic'
; Note: Mandatory when pm is set to 'dynamic'
pm.max_spare_servers = 35

只需要把蓝色部分前面的注释去掉,修改完成,试着启动

/usr/local/php/sbin/php-fpm &  

启动后用netstat -tnlp 查看 如果有如图所示端口 测表示正常启动

如需要开机自动启动 则可以添加到/etc/rc.d/rc.local中

vim /etc/rc.d/rc.local

在空白行添加   /usr/local/php/sbin/php-fpm &  


 

 

 

 配置fastcgi_params 文件
 

cd /etc/nginx/

vim fastcgi_params

将里面内容替换为

fastcgi_param  GATEWAY_INTERFACE  CGI/1.1;
fastcgi_param  SERVER_SOFTWARE    nginx;
fastcgi_param  QUERY_STRING       $query_string;
fastcgi_param  REQUEST_METHOD     $request_method;
fastcgi_param  CONTENT_TYPE       $content_type;
fastcgi_param  CONTENT_LENGTH     $content_length;
fastcgi_param  SCRIPT_FILENAME    $document_root$fastcgi_script_name;
fastcgi_param  SCRIPT_NAME        $fastcgi_script_name;
fastcgi_param  REQUEST_URI        $request_uri;
fastcgi_param  DOCUMENT_URI       $document_uri;
fastcgi_param  DOCUMENT_ROOT      $document_root;
fastcgi_param  SERVER_PROTOCOL    $server_protocol;
fastcgi_param  REMOTE_ADDR        $remote_addr;
fastcgi_param  REMOTE_PORT        $remote_port;
fastcgi_param  SERVER_ADDR        $server_addr;
fastcgi_param  SERVER_PORT        $server_port;
fastcgi_param  SERVER_NAME        $server_name;
# PHP only, required if PHP was built with --enable-force-cgi-redirect
fastcgi_param  REDIRECT_STATUS    200;

保存退出

 

 

 下面就是最后修改nginx.conf配置文件
 

vim /etc/nginx/nginx.conf

首先将

#user  nobody;
改为user  nginx;

之后找到

        location ~ \.php$ {
            root           /www;
            fastcgi_pass   127.0.0.1:9000;
            fastcgi_index  index.php;
            fastcgi_param  SCRIPT_FILENAME  /scripts$fastcgi_script_name;
            include        fastcgi_params;
        }

把前面注释全部去掉 root  后面的路径是你网页文件所放置的路径,笔者放在/www下 该目录如果不存在的话还需要手动创建。

找到

  location / {
            root   /www;
            index  index.php index.html index.htm;
        }

修改为如上所示 主要是添加index  后面的index.php

修改完成后保存退出,重新启动nginx服务

service nginxd restart

之后编辑/www/index.php

在其中添加

<?php
phpinfo();
?>

保存退出

之后用web浏览器访问 如果出现如下画面 表示服务成功,并能连接到php

 

 

 

 

 

 下面是测试msql 的连接
 

把刚才/www/index.php中的内容修改成

<?php
$link=mysql_connect("localhost","root","123456");
if(!$link) echo "FAILD!";
else echo "OK!";
?>

然后刷新web页面,如果出现OK!字样 测表示正常连接

 

如果都没有问题,那么恭喜你,你已经全源码成功实现LEMP架构。

好了,笔者经过两天时间终于写完这篇LEMP架构,其中也遇到不少问题,最终还是都一一解决了,但难免有理解错误或写错的地方,还望前辈们多加指点鼓励,笔者以后会与朋友们分享更多的知识和技术,希望能与君共同探讨,努力进步.